﻿<ResourceDictionary xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
                    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
                    xmlns:car="clr-namespace:SecondMonitor.Telemetry.TelemetryApplication.Controllers.Settings.Car;assembly=TelemetryApplication"
                    xmlns:wpf="clr-namespace:SecondMonitor.WindowsControls.WPF;assembly=WindowsControls"
                    xmlns:helpButton="clr-namespace:SecondMonitor.WindowsControls.WPF.HelpButton;assembly=WindowsControls">
    <ResourceDictionary.MergedDictionaries>
        <ResourceDictionary Source="../TelemetryPresentation.xaml" />
    </ResourceDictionary.MergedDictionaries>
    <DataTemplate DataType="{x:Type car:WheelPropertiesViewModel}">
        <Border BorderThickness="1" BorderBrush="{StaticResource DarkGrey01Brush}" Padding="10" CornerRadius="5" Background="{StaticResource Anthracite01Brush}">
            <Grid>
                <Grid.RowDefinitions>
                    <RowDefinition Height="Auto"/>
                    <RowDefinition Height="Auto"/>
                </Grid.RowDefinitions>
                <Grid Grid.Row="0">
                    <TextBlock Style="{StaticResource StandardText}" FontSize="{StaticResource NormalFontSize}" FontWeight="Bold" Text="{Binding WheelName}" Margin="5"/>
                </Grid>
                <StackPanel Grid.Row="1">
                    <StackPanel Orientation="Horizontal" Margin="5">
                        <TextBlock Style="{StaticResource StandardText}" Text="Ideal Camber: " Width="200"/>
                        <TextBox Style="{StaticResource StandardTextBox}" Margin="5,0,2,0" MinWidth="100" Text="{Binding IdealCamber, Converter={StaticResource DoubleToScalableDecimalsConverter}}"/>
                        <TextBlock Style="{StaticResource StandardText}" Text="{Binding AngleUnits}"/>
                    </StackPanel>

                    <StackPanel Orientation="Horizontal" Margin="5">
                        <TextBlock Style="{StaticResource StandardText}" Text="Bump Transition: " Width="200"/>
                        <TextBox Style="{StaticResource StandardTextBox}" Margin="5,0,2,0" MinWidth="100" Text="{Binding BumpTransition, Converter={StaticResource DoubleToScalableDecimalsConverter}}"/>
                        <TextBlock Style="{StaticResource StandardText}" Text="{Binding VelocityUnits}"/>
                    </StackPanel>

                    <StackPanel Orientation="Horizontal" Margin="5">
                        <TextBlock Style="{StaticResource StandardText}" Text="Rebound Transition: " Width="200"/>
                        <TextBox Style="{StaticResource StandardTextBox}" Margin="5,0,2,0" MinWidth="100" Text="{Binding ReboundTransition, Converter={StaticResource DoubleToScalableDecimalsConverter}}"/>
                        <TextBlock Style="{StaticResource StandardText}" Text="{Binding VelocityUnits}"/>
                    </StackPanel>

                    <StackPanel Orientation="Horizontal" Margin="5">
                        <TextBlock Style="{StaticResource StandardText}" Text="Spring Stiffness: " Width="200"/>
                        <TextBox Style="{StaticResource StandardTextBox}" Margin="5,0,2,0" MinWidth="100" Text="{Binding SprintStiffnessPerMm, Converter={StaticResource DoubleToScalableDecimalsConverter}}"/>
                        <TextBlock Style="{StaticResource StandardText}" Text="N/mm"/>
                    </StackPanel>

                    <StackPanel Orientation="Horizontal" Margin="5">
                        <TextBlock Style="{StaticResource StandardText}" Text="Neutral susp. travel: " Width="200"/>
                        <TextBox Style="{StaticResource StandardTextBox}" Margin="5,0,2,0" MinWidth="100" Text="{Binding NeutralSuspensionTravel, Converter={StaticResource DoubleToScalableDecimalsConverter}}"/>
                        <TextBlock Style="{StaticResource StandardText}" Text="{Binding DistanceUnits}"/>
                    </StackPanel>
                </StackPanel>
            </Grid>
        </Border>
    </DataTemplate>
    <DataTemplate DataType="{x:Type car:CarPropertiesViewModel}">
        <Border BorderThickness="1" BorderBrush="{StaticResource DarkGrey01Brush}" Padding="10" CornerRadius="5" Background="{StaticResource Anthracite01Brush}">
        <Grid>
            <Grid.RowDefinitions>
                <RowDefinition Height="Auto"/>
                <RowDefinition Height="Auto"/>
                <RowDefinition Height="Auto"/>
            </Grid.RowDefinitions>
            <Grid Grid.Row="0">
                <StackPanel>
                    <TextBlock Style="{StaticResource StandardText}" FontSize="{StaticResource BigFontSize}" FontWeight="Bold" Text="{Binding CarName}" Margin="5"/>
                    <Border BorderThickness="1" BorderBrush="{StaticResource DarkGrey01Brush}" Padding="10" CornerRadius="5" Background="{StaticResource Anthracite01Brush}">
                        <StackPanel>
                            <StackPanel Orientation="Horizontal" Margin="5">
                                <TextBlock Style="{StaticResource StandardText}" Text="Steering Lock: " Width="200"/>
                                <TextBox Style="{StaticResource StandardTextBox}" Margin="5,0,2,0" MinWidth="100" Text="{Binding SteeringLockDegrees, Converter={StaticResource DoubleToScalableDecimalsConverter}}"/>
                                <TextBlock Style="{StaticResource StandardText}" Text="°"/>
                            </StackPanel>
                        </StackPanel>
                    </Border>
                </StackPanel>
            </Grid>
                <Grid Grid.Row="1">
                <Grid.RowDefinitions>
                    <RowDefinition Height="Auto" />
                    <RowDefinition Height="Auto" />
                </Grid.RowDefinitions>
                <Grid.ColumnDefinitions>
                    <ColumnDefinition Width="Auto" />
                    <ColumnDefinition Width="Auto" />
                </Grid.ColumnDefinitions>
                <ContentPresenter Content="{Binding FrontLeftWheel}" Grid.Column="0" Grid.Row="0"/>
                <ContentPresenter Content="{Binding FrontRightWheel}" Grid.Column="1" Grid.Row="0"/>
                <ContentPresenter Content="{Binding RearLeftWheel}" Grid.Column="0" Grid.Row="1"/>
                <ContentPresenter Content="{Binding RearRightWheel}" Grid.Column="1" Grid.Row="1"/>
            </Grid>
            <DockPanel LastChildFill="False" DockPanel.Dock="Bottom" Grid.Row="2">
                <Button Height="55" HorizontalAlignment="Right" VerticalAlignment="Bottom" DockPanel.Dock="Left"
                        Command="{Binding OkCommand}"
                        Style="{StaticResource StandardButton}">
                    <Button.Content>
                        <wpf:ColorAbleIcon Margin="5,0,5,0"
                                           StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                            <ContentPresenter Content="{StaticResource OkIcon}" />
                        </wpf:ColorAbleIcon>
                    </Button.Content>
                </Button>
                <Button Height="55" HorizontalAlignment="Right" VerticalAlignment="Bottom" DockPanel.Dock="Left"
                        Command="{Binding CancelCommand}"
                        Style="{StaticResource StandardButton}">
                    <Button.Content>
                        <wpf:ColorAbleIcon Margin="5,0,5,0"
                                           StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                            <ContentPresenter Content="{StaticResource CancelIcon}" />
                        </wpf:ColorAbleIcon>
                    </Button.Content>
                </Button>
                <helpButton:HelpButton HelpUrl="https://gitlab.com/winzarten/SecondMonitor/-/wikis/Car-Settings-(Telemetry)" Height="55" DockPanel.Dock="Right"/>
            </DockPanel>
        </Grid>
        </Border>
    </DataTemplate>

    <DataTemplate DataType="{x:Type car:LapCarSettingsViewModel}">
        <Border Padding="5" BorderThickness="1" BorderBrush="{StaticResource LightGrey02Brush}">
            <Grid>
                <Grid.ColumnDefinitions>
                    <ColumnDefinition Width="Auto" />
                    <ColumnDefinition Width="Auto" />
                </Grid.ColumnDefinitions>
                <Grid Column="0">
                    <StackPanel Orientation="Vertical">
                        <Button Width="32" HorizontalAlignment="Right" VerticalAlignment="Bottom" DockPanel.Dock="Left"
                                Command="{Binding LoadCarSettingsFromLapCommand}"
                                Style="{StaticResource StandardButton}" IsEnabled="{Binding IsLoadCarSettingsEnabled}"
                                ToolTip="Loads Car settings specific for that lap">
                            <Button.Content>
                                <wpf:ColorAbleIcon Margin="-2"
                                                   StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                    <ContentPresenter Content="{StaticResource PreviousFrame}" />
                                </wpf:ColorAbleIcon>
                            </Button.Content>
                        </Button>
                        <Button Width="32" HorizontalAlignment="Right" VerticalAlignment="Bottom" DockPanel.Dock="Left"
                                Command="{Binding ApplyCarSettingsToLapCommand}"
                                Style="{StaticResource StandardButton}"
                                ToolTip="Applies the car settings to that lap">
                            <Button.Content>
                                <wpf:ColorAbleIcon Margin="-2"
                                                   StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                    <ContentPresenter Content="{StaticResource NextFrame}" />
                                </wpf:ColorAbleIcon>
                            </Button.Content>
                        </Button>

                        <!--<Button Width="32" HorizontalAlignment="Right" VerticalAlignment="Bottom" DockPanel.Dock="Left"
                                Command="{Binding LoadCarSettingsFromLapCommand}"
                                Style="{StaticResource StandardButton}">
                            <Button.Content>
                                <wpf:ColorAbleIcon Margin="-2"
                                                   StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                    <ContentPresenter Content="{StaticResource CancelIcon}" />
                                </wpf:ColorAbleIcon>
                            </Button.Content>
                        </Button>
                        -->

                    </StackPanel>
                </Grid>
                <Grid Column="1" VerticalAlignment="Center">
                    <StackPanel Orientation="Horizontal">
                        <TextBlock Style="{StaticResource StandardText}" FontSize="{StaticResource BigFontSize}" Text="Lap:" Margin="5,0,0,0" />
                        <TextBlock Style="{StaticResource StandardText}" FontSize="{StaticResource BigFontSize}" Text="{Binding Name}" />
                    </StackPanel>
                </Grid>
            </Grid>
        </Border>
    </DataTemplate>

    <DataTemplate DataType="{x:Type car:CarSettingsWindowViewModel}">
        <Grid Background="{StaticResource Anthracite01Brush}">
            <Grid.ColumnDefinitions>
                <ColumnDefinition Width="Auto"/>
                <ColumnDefinition Width="Auto"/>
            </Grid.ColumnDefinitions>
            <ContentPresenter Content="{Binding CarPropertiesViewModel}" Grid.Column="0"></ContentPresenter>
            <Grid Column="1">
                <ScrollViewer  DockPanel.Dock="Bottom">
                    <ItemsControl ItemsSource="{Binding LapCarSettingsViewModels}" Margin="10"/>
                </ScrollViewer>
            </Grid>
        </Grid>
    </DataTemplate>
</ResourceDictionary>